﻿using System;
using System.Collections.Generic;
using EPiServer.Core;
using EPiServer.Shell.ObjectEditing;
using EPiServer.Shell.ObjectEditing.EditorDescriptors;

namespace EPiServer.Templates.Alloy.Business.EditorDescriptors
{
    /// <summary>
    /// Registers an editor to select an author.
    /// </summary>
    [EditorDescriptorRegistration(TargetType = typeof(string), UIHint = "author")]
    public class AuthorEditorDescriptor : EditorDescriptor
    {
        public override void ModifyMetadata(ExtendedMetadata metadata, IEnumerable<Attribute> attributes)
        {
            ClientEditingClass = "alloy.editors.AuthorSelector";

            base.ModifyMetadata(metadata, attributes);
        }
    }
}