﻿define([
// Dojo
    "dojo",
    "dojo/_base/declare",
    "dojo/dom-geometry",

// Dijit
    "dijit/_TemplatedMixin",
    "dijit/_Container",
    "dijit/layout/_LayoutWidget",
    "dijit/_WidgetsInTemplateMixin",

// EPi CMS
    "epi/cms/component/ContentQueryGrid",
    "dojo/text!./templates/CustomSearch.html"
], function (
// Dojo
    dojo,
    declare,
    domGeometry,

// Dijit
    _TemplatedMixin,
    _Container,
    _LayoutWidget,
    _WidgetsInTemplateMixin,

// EPi CMS
    ContentQueryGrid,
    template
) {

    return declare("app.components.CustomSearch", [_Container, _LayoutWidget, _TemplatedMixin, _WidgetsInTemplateMixin], {
        // summary: This component enabled searching of content where the results will be displayed in a grid.

        templateString: template,

        postCreate: function () {

            this.inherited(arguments);
        },

        resize: function (newSize) {
            // summary:
            //      Customize the default resize method.
            // newSize: object
            //      The new size of the custom query component.
            // tags:
            //      Public

            this.inherited(arguments);

            var toolbarSize = domGeometry.getMarginBox(this.toolbar);
            var gridSize = { w: newSize.w, h: newSize.h - toolbarSize.h }

            this.contentQuery.resize(gridSize);
        },

        _reloadQuery: function () {
            this.contentQuery.set("queryParameters", { queryText: this.queryText.value });
            this.contentQuery.set("queryName", "CustomQuery");
        }
    });
});