﻿define([
    "dojo/_base/array",
    "dojo/_base/connect",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dijit/_CssStateMixin",
    "dijit/_Widget",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/form/ComboBox",

    "epi/dependency",
    "epi/epi",
    "epi/routes",
    "epi/shell/widget/_ValueRequiredMixin"
],
function (
    array,
    connect,
    declare,
    lang,

    _CssStateMixin,
    _Widget,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,

    ComboBox,

    dependency,
    epi,
    routes,
    _ValueRequiredMixin
) {

    return declare("alloy.editors.AuthorSelector", [_Widget, _TemplatedMixin, _WidgetsInTemplateMixin, _CssStateMixin, _ValueRequiredMixin], {

        templateString: "<div class=\"dijitInline\">\
                            <div data-dojo-attach-point=\"stateNode, tooltipNode\">\
                                <div data-dojo-attach-point=\"inputWidget\" data-dojo-type=\"dijit.form.ComboBox\" style=\"width: 300px\"></div>\
                            </div>\
                        </div>",

        intermediateChanges: false,

        value: null,

        store: null,

        onChange: function (value) {
            // Event
        },

        postCreate: function () {
            // call base implementation
            this.inherited(arguments);

            // Init textarea and bind event
            this.inputWidget.set("intermediateChanges", this.intermediateChanges);

            var registry = dependency.resolve("epi.storeregistry");
            this.store = this.store || registry.get("alloy.Authors");
            
            this.inputWidget.set("store", this.store);
            this.connect(this.inputWidget, "onChange", this._onInputWidgetChanged);

        },

        isValid: function () {
            // summary:
            //    Check if widget's value is valid.
            // tags:
            //    protected, override

            return this.inputWidget.isValid();
        },

        // Setter for value property
        _setValueAttr: function (value) {
            this.inputWidget.set("value", value);
            this._set("value", value);
        },

        _setReadOnlyAttr: function (value) {
            this._set("readOnly", value);
            this.inputWidget.set("readOnly", value);
        },

        // Event handler for the changed event of the input widget
        _onInputWidgetChanged: function (value) {
            this._updateValue(value);
        },

        _updateValue: function (value) {
            if (this._started && epi.areEqual(this.value, value)) {
                return;
            }

            this._set("value", value);
            this.onChange(value);
        }
    });
});