﻿using System.ComponentModel.DataAnnotations;
using EPiServer.DataAbstraction;
using EPiServer.DataAnnotations;
using EPiServer.Framework.DataAnnotations;
using EPiServer.Shell.ObjectEditing;
using EPiServer.Web;
using EPiServer.Core;

namespace EPiServer.Templates.Alloy.Models.Pages
{
    [ContentType(GUID = "F8D47655-7B50-4319-8646-3369BA9AF05E")]
    public class MyPage : SitePageData
    {
        //Validate string according to email as defined in the default EPiServer email regex.
        [RegularExpression(EPiServer.Framework.Validator.DefaultEmailRegexString, ErrorMessage="Not a valid email")]
        public virtual string Email { get; set; }

        [Range(1, 130)]
        public virtual int Age { get; set; }

        //Give a hint that this property should be edited as a "author".
        //Does not know how authors are edited, this is defined in an EditorDescriptor
        [UIHint("author", PresentationLayer.Edit)]
        [Display(Name = "Author", GroupName = SystemTabNames.Content)]
        public virtual string Author { get; set; }

        //It's also possible to use the ClientEditor attribute to skip the
        //editor descriptor although we recomend the editor descriptor
        //to keep a clearer separation of UI and model.
        //[ClientEditor(ClientEditingClass = "alloy.editors.AuthorSelector")]
        //[Display(Name = "Author", GroupName = SystemTabNames.Content)]
        //public virtual string Author { get; set; }
    }
}