﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using EPiServer.Shell.Services.Rest;

namespace EPiServer.Templates.Alloy.Rest
{
    [RestStore("Authors")]
    public class CustomQueryStore : RestControllerBase
    {
        private List<string> _editors = new List<string>{
            "Adrian", "Ann", "Anna", "Anne", "Linus", "Per",
            "Joel", "Shahram", "Ted", "Patrick", "Erica", "Konstantin", "Abraham", "Tiger"
        };

        public RestResult Get(string name)
        {
            IEnumerable<string> matches;
            if (String.Equals(name, "*", StringComparison.OrdinalIgnoreCase))
            {
                matches = _editors;
            }
            else
            {
                //Remove * in the end of name
                name = name.Substring(0, name.Length - 1);
                matches = _editors.Where(e => e.StartsWith(name, StringComparison.OrdinalIgnoreCase));
            }

            return Rest(matches
                    .OrderBy(m => m)
                    .Take(10)//We take a fixed amount just in case we have a lots of potential hits.
                    .Select(m => new {Name = m, Value = m}));
        }
    }
}